# Template Java Project

## Java environment

Where install jdk, path to java and javac

In order to be able to compile and run Java code, you need to install a JDK (Java Development Kit) on your computer.
A JDK contains a java compiler (`javac`) and a java interpreter (`java` - JRE = Java Runtime Environment).

Recommended JDK for windows : https://adoptium.net/temurin/releases/?os=windows&arch=x64&package=jdk.

You can find other JDKs at https://openjdk.org/install/ (latest JDK at https://jdk.java.net/).

**If you are using Linux or MacOS, you should install a JDK using your package manager** (apt, brew, ...).

### Commands

In this template project, we have chosen the following points :

- use `src/` as the source directory (containing all java files)
- use `out/` as the output directory (containing all compiled `.class` files)
- use `src/Main.java` as the main file of the java program

From this configuration, you can use the following commands in the `java/` folder in order to compile and run your program.

```bash
javac -sourcepath src -d out src/Main.java # Compile
java -classpath out Main # Run
```

### Linux / MacOS - Makefile

For OS that support the `make` command, the [`Makefile`](./Makefile) defines some commands to compile, run and clean your project.
You can use it to personalize the project structure.

```bash
make compile # Compile the project
make run # Run the project
make clean # Clear the output directory
make # Compile, clear terminal and run
```

## VSCode Project Settings

Relevant settings with Java :

- format on save

## Formatter - Java Red Hat

The Java extension for VSCode provides a formatter.
Using a formatter ensures that the code you and your team write is consistent.
You should always use a formatter.

### Git

Some common gitignores for a Java project :

- `out/` : the compiled output. In this project we specify to the compiler that it must output its `.class` compiled files to this directory. It may not be the same for every project.
- `*.class` : just to be safe : be sure not to version output files.
